/*
 * $Id: 
 */
#define AROS_ALMOST_COMPATIBLE
#include "global.h"
#include <proto/iffparse.h>
#include <aros/asmcall.h>

#define DEBUG 0
#include <aros/debug.h>


struct SerialInfo
{
	ULONG sp_Unit0Map;
	ULONG sp_BaudRate;

	ULONG sp_InputBuffer;
	ULONG sp_OutputBuffer;

	ULONG sp_InputHandshake;
	ULONG sp_OutputHandshake;

	ULONG sp_Parity;
	ULONG sp_BitsPerChar;
	ULONG sp_StopBits;
};

AROS_UFH1(LONG, SerialPrefs_Handler,
		  AROS_UFHA(struct IFFHandle *, iff, A2))
{
	AROS_LIBFUNC_INIT

	struct SerialPrefs iprefs;
	struct SerialInfo  sinfo;

	D(bug("IPrefs: SerialPrefs\n"));

	if (ReadChunkBytes(iff, &iprefs, sizeof(iprefs)) == sizeof(iprefs))
	{
		sinfo.sp_Unit0Map = iprefs.sp_Unit0Map;
		sinfo.sp_BaudRate = iprefs.sp_BaudRate;

		sinfo.sp_InputBuffer = iprefs.sp_InputBuffer;
		sinfo.sp_OutputBuffer = iprefs.sp_OutputBuffer;

		sinfo.sp_InputHandshake = iprefs.sp_InputHandshake;
		sinfo.sp_OutputHandshake = iprefs.sp_OutputHandshake;

		sinfo.sp_Parity = iprefs.sp_Parity;
		sinfo.sp_BitsPerChar = iprefs.sp_BitsPerChar;
		sinfo.sp_StopBits = iprefs.sp_StopBits;   


		SetIPrefs(&sinfo, sizeof(sinfo), IP_SERIAL);
	}

	return 0;

	AROS_LIBFUNC_EXIT
}
